import math
import const

def out_of_bounds(sprite):
    h2 = sprite.rect.height / 2
    w2 = sprite.rect.width / 2
    return (sprite.pos[0] + w2 < 0 or sprite.pos[0] - w2 > const.WIDTH or
            sprite.pos[1] + h2 < 0 or sprite.pos[1] - h2 > const.HEIGHT)

def go_towards(pos_orig, target, speed, dt):
    pos = list(pos_orig)
    dx = pos[0] - target[0]
    dy = pos[1] - target[1]
    dist = math.hypot(dx, dy)
    if dist <= speed * dt:
        pos[0] = target[0]
        pos[1] = target[1]
    else:
        pos[0] -= speed * dt * dx / dist
        pos[1] -= speed * dt * dy / dist
    return pos
